{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O+,R-,S+,V-,X+}
{$M 16384,0,655360}
PROGRAM TextmodusSpielerei;

USES CRT;

{----------------------------------------------------------------------------}
{ Setzt die Anzahl der Scanlines, die dargestellt werden:                    }
{  n=0 = 200 Scanlines (CGA-Auflsung, double scan)                          }
{  n=1 = 350 Scanlines (EGA-Auflsung)                                       }
{  n=2 = 400 Scanlines (VGA-Auflsung)                                       }
{----------------------------------------------------------------------------}
PROCEDURE Scanline(n:BYTE); ASSEMBLER;
ASM
        MOV     AH,12h
        MOV     BL,30h
        MOV     AL,n
        INT     10h
END;

{----------------------------------------------------------------------------}
{ Ldt einen ROM-Font:                                                       }
{  n=14h = VGA-Font 9x16 Pixel                                               }
{  n=11h = EGA-Font 8x14 Pixel                                               }
{  n=12h = CGA-Font 8x8 Pixel                                                }
{----------------------------------------------------------------------------}
PROCEDURE Line(n:BYTE); ASSEMBLER;
ASM
        MOV     AH,11h
	MOV	AL,n
        MOV     BX,0
        INT     10h
END;

VAR ParaStr:STRING;
    Lines,Cols:BYTE;

CONST ShowState:BOOLEAN=FALSE;

FUNCTION Readkey:CHAR;
BEGIN
  IF ParaStr<>'' THEN BEGIN
    CASE Upcase(ParaStr[1]) OF
      'X':IF ParaStr[Length(ParaStr)]=#27 THEN Dec(ParaStr[0]);
      'S':ShowState:=TRUE;
    END;
    Readkey:=ParaStr[1];
    Delete(ParaStr,1,1);
  END ELSE Readkey:=CRT.Readkey;
END;

PROCEDURE Getstate; ASSEMBLER;
ASM
		push	bp
		mov	ax,1130h
		mov	bh,0
		int	10h
		pop	bp
		inc	dx
		mov	Lines,dl

		mov	ah,0Fh
		int	10h
		mov	Cols,ah
END;

PROCEDURE DoShowState;
VAR w:BYTE;
BEGIN
  WriteLn('Current Mode:');
  WriteLn(Lines,' lines, ',Cols,' columns.');
END;

VAR Ch:CHAR;
    Doit:BOOLEAN;
    W,m:BYTE;

BEGIN
  ParaStr:='';
  FOR m:=1 TO ParamCount DO ParaStr:=ParaStr+ParamStr(m);
  IF Pos('?',ParaStr)<>0 THEN BEGIN
    Writeln('TM - Text Mode Switching Utility - (c) 1994-96 by Streu Software');
    Writeln;
    Writeln('Usage: TM [-options]');
    Writeln;
    Writeln('Valid options:');
    Writeln('  -2, -3, -4   Set Scanline Count (200, 350 or 400)');
    Writeln('  -a, -b, -c   Set Font Size (16x9, 14x8, 8x8)');
    Writeln('  -m           Toggle screen width (80 / 40)');
    Writeln('  -x           After run stay in interactive mode');
    Writeln('  -s           After run show status');
    Halt;
  END;
  IF ParaStr<>'' THEN ParaStr:=ParaStr+#27;
  Doit:=FALSE;
  m:=3;
  ClrScr;
  REPEAT
    IF Doit THEN TextMode(m);
    Doit:=TRUE;

    IF ParaStr='' THEN BEGIN
      TextAttr:=7;
      GotoXY(1,1);
      WriteLn('VGA Text Mode Switching Utility');
      GetState;
      FOR w:=1 TO Cols-1 DO Write('-');
      Writeln;
      DoShowState;
      FOR w:=1 TO Cols-1 DO Write('-');
      Writeln;
      WriteLn('Resolution:              Lines:');
      WriteLn(' [2] 200 scanlines        [A] 16x9 font');
      WriteLn(' [3] 350 scanlines        [B] 14x8 font');
      WriteLn(' [4] 400 scanlines        [C] 8x8 font');
      WriteLn(' [M] 40/80 columns');
      Write('Choose:');
    END;
    Ch:=Upcase(Readkey);
    CASE Ch OF
      #0:BEGIN
        Readkey;
        Doit:=FALSE;
      END;
      '2':Scanline(0);
      '3':Scanline(1);
      '4':Scanline(2);
      'M':m:=m XOR 2;
      'A':BEGIN
        Line($14);
        Doit:=FALSE;
      END;
      'B':BEGIN
        Line($11);
        Doit:=FALSE;
      END;
      'C':BEGIN
        Line($12);
        Doit:=FALSE;
      END;
    ELSE Doit:=FALSE;
    END;
  UNTIL Ch=#27;
  Writeln;
  IF ShowState THEN BEGIN
    GetState;
    DoShowState;
  END;
END.